/*
 *	 This short program selects a single record
 *	 and prints the contents of a blob field in
 * the record.
 */
EXEC SQL BEGIN DECLARE SECTION;
EXEC SQL END DECLARE SECTION;

#ifdef apollo
#define NULL_STATUS *gds__null
#else
#define NULL_STATUS (long*) 0
#endif

main ()
{
GDS__QUAD	blob_id;
long		blob_handle;
char		segment [60], string [61];
unsigned short	length;

EXEC SQL SELECT T.GUIDEBOOK INTO :blob_id FROM TOURISM T WITH
	T.STATE = "ME";
if (SQLCODE)
    {
    gds__print_status (gds__status);
    exit (1);
    }
    
/* the blob handle must be initialized to zero before the blob 
open call */

blob_handle = 0;  		

gds__open_blob (NULL_STATUS, GDS_REF(gds__database), GDS_REF(gds__trans), 
                GDS_REF(blob_handle), GDS_REF(blob_id));
for (;;)
    {
    gds__status[1] = gds__get_segment (NULL_STATUS,
			    GDS_REF(blob_handle), GDS_REF(length), sizeof (segment), GDS_VAL(segment));
    if (gds__status[1] && (gds__status[1] != gds__segment)) 
				 break;
    strncpy (string, segment, length);
    string[length] = 0;
    printf ("%s\n", string);
    }
if (gds__status[1] != gds__segstr_eof)
    gds__print_status (gds__status);

EXEC SQL
	  COMMIT RELEASE;
exit (0);
}
