#include <stdio.h>

DATABASE DB = 'atlas.gdb';

EXEC SQL 
    INCLUDE SQLCA;


EXEC SQL
    WHENEVER SQLERROR GO TO ERR;
    
SQLDA *sqlda;
GDS__QUAD blob;
short flag;
char *query = "SELECT GUIDEBOOK FROM TOURISM                  \
	 WHERE STATE = 'NY'";

main ()
{
    READY;
    START_TRANSACTION;
    
    sqlda = (SQLDA*) malloc (SQLDA_LENGTH (1));
    sqlda->sqln = 1;
    
    EXEC SQL
        PREPARE Q INTO sqlda FROM :query;
    
    sqlda->sqlvar[0].sqldata = (char*) &blob;
    sqlda->sqlvar[0].sqlind  = &flag;
    
    EXEC SQL
        DECLARE C CURSOR FOR Q;
    
    EXEC SQL
        OPEN C;
    
    EXEC SQL
        FETCH C USING DESCRIPTOR sqlda;
    
    if (SQLCODE)
        gds__print_status (gds__status);
    else
        BLOB_display (&blob, DB, gds__trans, "");
    
    EXEC SQL
        COMMIT RELEASE;
    exit (0);
    ERR: printf ("Data base error, SQLCODE = %d\n", SQLCODE);
     gds__print_status (gds__status);

     EXEC SQL
        ROLLBACK RELEASE;

     exit (1);
}
