#include <stdio.h>

EXEC SQL BEGIN DECLARE SECTION;
EXEC SQL END DECLARE SECTION;

char		*months[]  = { 
	    "January", "February", "March", "April", 
	    "May", "June", "July", "August", "September", 
	    "October", "November", "December"
	    };

#ifdef VMS
#define TIME_DEFINED
#include <time.h>
#endif

#ifdef apollo
#define TIME_DEFINED
#include <sys/time.h>
#endif

#ifdef sun
#define TIME_DEFINED
#include <sys/time.h>
#endif

#ifdef hpux
#define TIME_DEFINED
#include <sys/time.h>
#endif

#ifdef ultrix
#define TIME_DEFINED
#include <sys/time.h>
#endif

#ifdef DGUX
#define TIME_DEFINED
#include <sys/time.h>
#endif

#ifdef sgi
#define TIME_DEFINED
#include <sys/time.h>
#endif

#ifdef mpexl
#define TIME_DEFINED
#include <sys/time.h>
#endif

#ifndef TIME_DEFINED
#include <time.h>
#endif

main ()
{
GDS__QUAD	date;
char		state [26];
struct tm	time;
short		year;

EXEC SQL DECLARE C CURSOR FOR
	SELECT S.STATE_NAME, S.STATEHOOD FROM STATES S
		WHERE S.STATEHOOD IS NOT NULL
		ORDER BY S.STATEHOOD;


EXEC SQL OPEN C;

if (!SQLCODE)
    EXEC SQL FETCH C INTO :state, :date;
    
while (!SQLCODE)
    {
    gds__decode_date (&date, &time);
    year = 1900 + time.tm_year;
    printf ("%s entered the union on %s %d, %4d\n",
		state, months[time.tm_mon],
		time.tm_mday, year);  
    EXEC SQL FETCH C INTO :state, :date; 
    }
if (SQLCODE != 100)
    gds__print_status (gds__status);
EXEC SQL
	  COMMIT RELEASE;
exit (0);
}
